/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/CFASM/main.c                        $
 *     $Date:: 19/06/02 10:34                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <rtems.h>
#include <chameleon.h>

/******************************************************************************/
#define WORKSPACE_SIZE	128*1024
rtems_unsigned32 rtems_workspace_size = WORKSPACE_SIZE;
rtems_unsigned32 rtems_workspace_start[WORKSPACE_SIZE];
/******************************************************************************/

int add_asm1(int operand1, int operand2)
{
	/* this code does operand2 += operand1; see gcc.pdf page 166 */
	
	asm ("add.l %2,%0" : "=r" (operand2) : "0" (operand2), "g" (operand1));
	
	return operand2;
}

extern int add_asm2(int operand1, int operand2);

rtems_boolean work(void)
{
	int operand1, operand2;
	int panel;

	TRACE("******************************************************************************\n");
	TRACE("ColdFire Assembler example\n");
	TRACE("******************************************************************************\n");

	panel = panel_init();
	if (!panel)
	{
		TRACE("ERROR: cannot access the panel.\n");
		return FALSE;
	}

	panel_out_lcd_print(panel, 0, 0, "   ColdFire    ");
	panel_out_lcd_print(panel, 1, 0, "   Assembler   ");

	operand1 = 1234;
	operand2 = 5678;
	
	/* Testing the first method of calling assembler code */
	TRACE("add_asm1(%d, %d) = %d\n", operand1, operand2, add_asm1(operand1, operand2));
	
	/* Testing the second method of calling assembler code */
	TRACE("add_asm2(%d, %d) = %d\n", operand1, operand2, add_asm2(operand1, operand2));

	panel_exit(panel);

	return TRUE;
}

rtems_task rtems_main(rtems_task_argument ignored)
{
	work();
	rtems_task_delete(RTEMS_SELF);
}
